/* $Id: com_gw.c,v 1.8 1996/07/16 20:34:47 lexa Exp $ */


/* (C) Alex Tutubalin, 1996, lexa@lexa.ru       */


#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h> 
#include <string.h>
#include <stdlib.h>
#include <signal.h>

#include "policy.h"
#include "readconf.h"
#include "gateway.h"


unsigned char buf[BSIZE];

void
TranslateBuf (unsigned char *buf, int len, unsigned char *table)
{
  int i;
  if(table==NULL) return;
  for(i=0;i<len;i++)
    if(table[buf[i]]!=0) buf[i] = table[buf[i]];
}



void 
simple_gw(int in, int out, GW_func  *dpipe,encoding *enc,int timeout)
{
  int  firstdata,file_bits,n;
  fd_set fd;
  struct timeval tv;

    alarm(0);
    firstdata=FIRST_DATA;
    file_bits=in>out?in+1:out+1;

    while (1) {
        FD_ZERO(&fd);
        FD_SET(in, &fd);
        FD_SET(out, &fd);
        tv.tv_sec = timeout;
        tv.tv_usec = 0;
        if ((n = select(file_bits, &fd, NULL, NULL, &tv)) > 0) {
            if (FD_ISSET(in , &fd) && (ERROR==dpipe( in , out, FROM_CLIENT,firstdata,enc))) 
	      return;
            if (FD_ISSET(out, &fd) && (ERROR==dpipe( out , in,TO_CLIENT,firstdata,enc))) 
	      return;
	    firstdata=SECOND_DATA;
        } 
        else return;
    }
}


static int
simplePipe(int in,int out, enum Direction fclient, enum Dataset fd,encoding* enc)
{
  int dsize;
  
  if(0==(dsize=read(in,buf,BSIZE))) return ERROR;
  else {
    if(fclient==FROM_CLIENT)
      TranslateBuf(buf,dsize,enc->tablefrom);
    else
      TranslateBuf(buf,dsize,enc->tableto);
    if(dsize!=write(out,buf,dsize)) return ERROR;
  }
  return OK;
}

void 
DefaultGW (int in, int out, encoding *enc, int timeout)
{
  simple_gw(in,out,simplePipe,enc,timeout);
}

#ifdef TRANSPARENT_HOST
static int
transparentPipe(int in,int out, enum Direction fclient, enum Dataset fd,encoding* enc)
{
  int dsize;
  
  if(0==(dsize=read(in,buf,BSIZE))) return ERROR;
  if(dsize!=write(out,buf,dsize)) return ERROR;
  return OK;
}


void  transparentGW(int in, int out,encoding *enc, int timeout)
{
  simple_gw(in,out,transparentPipe,enc,timeout);
}
#endif



