/*

     

    (C) Vadim Kurland, 1994

    vadim@gu.kiev.ua

    -  .   
     ,        
       ,     .   
      ,      
       .

       cyrproxy - Alex Tutubalin, lexa@lexa.ru, 1996
 */


#include	<stdio.h>
#include	<unistd.h>
#include 	<string.h>
#include	<syslog.h>

#include 	"policy.h"
#include	"readconf.h"
#include	"gateway.h"

static char ClientType = 0;

static int 
gopherFromClient( FILE *inf, int out, encoding *enc )
{
  ClientType=0;

  if ( fgets( buf , BSIZE-2 , inf)!=NULL ) {
    DebugLog("gopherClient: %s",buf);
    ClientType = (buf[0]=='\r') ? '1' : buf[0];
    write(out, buf,strlen(buf));
    return OK;
  }
  return ERROR;
} 

static int 
gopherToClient(FILE *inf, int out, encoding *enc )
{
  int blen;
  while ( fgets( buf , BSIZE-2, inf)!=NULL ) {
    blen = strlen(buf);
#ifdef DEBUGLOG
    syslog(DEBUGLOG,"gopherServer: (type=%d; bytes=%d): %s",
	   ClientType,blen,buf);
#endif
    if(ClientType==1 || ClientType==2)
	TranslateBuf(buf,blen,enc->tableto);
    write(out, buf,blen);
    if ( blen >= 1 && buf[0]=='.' && buf[1]=='\r' ) 
      {
      DebugLog("gopherServer: end of data");
      return OK;
      }
  }
  return ERROR;
} 

static int 
gopherPipe(int in, int ou, enum Direction fdir, enum Dataset fd, encoding *enc) 
{
  int ret;
  if(fdir==FROM_CLIENT)
    ret= gopherFromClient(fdopen(in,"r"),ou,enc);
  else
    ret= gopherToClient(fdopen(ou,"r"),in,enc);
  return ret;
}
    

void  
GopherGW (int in, int out, encoding *enc, int timeout)
{
  simple_gw(in,out,gopherPipe,enc,timeout);
}




