/* $Id: http_gw.c,v 1.7 1996/10/27 14:08:15 lexa Exp $ */
/*  
    (C) 1996, Alex Tutubalin, lexa@lexa.ru
       HTTP ( cyrpoxy)

*/



#include	<stdio.h>
#include	<ctype.h>
#include 	<string.h>
#include	<syslog.h>
#include 	<stdlib.h>
#include 	<stdio.h>
#include 	<sys/errno.h>
#include	<stdarg.h>
#include	<unistd.h>
#include	<sys/fcntl.h>
#include	<sys/stat.h>
#include 	<sys/types.h>
#include 	<sys/time.h>


#include 	"policy.h"
#include 	"readconf.h"
#include 	"gateway.h"


static encoding *client_enc;
static int  IsHTTP_1_0=0;

#define BUFSIZE (BSIZE/2)
static char urlbuf[BUFSIZE*3+1]; /* urltranslate() will put results in this buffer */
#define mmin(a,b) ((a)<(b)?(a):(b))
#define mmax(a,b) ((a)>(b)?(a):(b))
#define strws(a)  strtok(a," \t\r\n")

#define TEXT	1
#define BINARY	0


static int    
empty_line(char *word)
{
  if(!word) return 1;
  while(*word && strchr(" \t\r\n",*word)) word++;
  if(*word) return 0; else return 1;
}


/* 
   unescape convert all %xx to appropriate characters and escape all normal characters
   into '\char' form (so we can do reverce operation in correct way)
 */
static void 
unescape(unsigned char *dest,unsigned char *str)
{
  char *p,*dst;
  char buf[] = "0x00";

  for(p=str,dst = dest;*p;) 
    {
      if(*p=='%')
	{
	  if(isxdigit(buf[2]=*(p+1)) && isxdigit(buf[3]=*(p+2)))
	    {
	      *dst++=strtol(buf,NULL,16); p+=3;
	      continue;
	    }
	  else
	    { 
	      /* we have '%' in *p and _NO_ hexdigit in following two symbols */
	      /* this is error, so we simply SKIP 3 chars. This is
		 INCORRECT, but starting data is also incorrect */
	      p+=3;
	    }
	}
      else /* Escape non-escaped char */
	{
	  *dst++='\\';
	  *dst++=*p++;
	}
    }
  *dst=0;
}


#define c2h(v) ((v)<10?(v)+'0':(v)-10+'A')
static void
chr2hex(unsigned char *dst,unsigned int val)
{
  dst[0]='%'; dst[1]=c2h(val>>4); dst[2]=c2h(val&0xf); dst[3]=0;
}


/* complementary function to unescape() */
static void
escape(unsigned char *dest, unsigned char *str)
{
  unsigned char *dst,*p;
  for(p=str,dst=dest;*p;p++)
    {
      if(*p=='\\') /* early escaped char -> skip backslash */
	*dst++=*++p;
      else
	{
	  chr2hex((unsigned char *) dst,(unsigned int)*p);
	  dst+=3;
	}
    }
  *dst=0;
}


void
url_translate(char *url)
{
  unsigned char wrkbuf[BUFSIZE*3+1];
  unescape(wrkbuf,url);
  TranslateBuf(wrkbuf,strlen(wrkbuf),client_enc->tablefrom);
  escape(urlbuf,wrkbuf);
}

static int 
strmatch(char *string, char *pat)
{
  if(!string || !*string) return 0;
  return !strncasecmp(string,pat,strlen(pat));
}

static int
writestr(int file, char *str)
{
  return write(file,str,strlen(str));
}

/* Is this header string must be passed to server ?*/
char *rejectedClientHeaders[]= 
{
  "Connection:"
};

#define NrejectedClientHeaders (sizeof(rejectedClientHeaders)/sizeof(rejectedClientHeaders[0]))

static int 
PassToServer(char *str)
{
  int i;
  for (i=0;i<NrejectedClientHeaders;i++)
    if(strmatch(str,rejectedClientHeaders[i])) return 0;
  return 1;
}

/* Is this header string must be passed to client ?*/
char *rejectedServerHeaders[]=
{
  "Connection:",
  "Keep-Alive:"
};
#define NrejectedServerHeaders (sizeof(rejectedServerHeaders)/sizeof(rejectedServerHeaders[0]))

static int 
PassToClient(char *str)
{
  int i;
  for (i=0;i<NrejectedServerHeaders;i++)
    if(strmatch(str,rejectedServerHeaders[i])) return 0;
  return 1;
}



static int
http_request(int in,  int out)
{
  char *url,*Proto;
  int n = 0,ClientAcceptKoi8=0;
  FILE           *ifs;
  static char *HTTP_Method=NULL;
  static int RequestLength = 0, RequestType = BINARY;
  
  if (HTTP_Method) { 
    /* We've read and parse header at previous pass(es)*/
    if((n=read(in,buf,BUFSIZE))>=0){
      TranslateBuf(buf,n,0);
      if(write(out,buf,n)<0) return 1;
    }else 
      return 1;
    return 0;
  }

  ifs=fdopen(in,"r");
  if (fgets(buf, BUFSIZE, ifs) == NULL)
    return (1);
  
  HTTP_Method = strdup(strws(buf));
  url = strws(NULL);
  Proto = strws(NULL);

  IsHTTP_1_0=strmatch(Proto,"HTTP/1");

  if (empty_line(HTTP_Method) || empty_line(url))    return (1);
  url_translate(url); 
  sprintf(buf, "%s %s HTTP/1.0\n",HTTP_Method,urlbuf);
 
  if (writestr(out, buf) < 0) return (1);
  
  if (IsHTTP_1_0) {
    while ((fgets(buf, BUFSIZE, ifs)) != NULL) {
      ClientAcceptKoi8 += strmatch(buf,"Accept:") && strstr(buf, "x-cyrillic-koi8");
      if (strmatch(buf, "User-Agent:")) {
	unsigned char *bp;
	for (bp = buf + strlen(buf); bp > buf && (strchr("\n\r",*bp) || *bp == 0); bp--)
	  *bp = 0;
	strcat(buf, " Modified via cyrproxy gateway\r\n");
      }
      if (strmatch(buf, "Content-Length:")) 	{
	char *w1,*w2;
	strcpy(urlbuf,buf); /* leave buf untouched */
	w1 = strws(urlbuf);
	w2 = strws(NULL);
	RequestLength = atoi(w2);
      }
      if (strmatch(buf, "Content-Type:")  && (strstr(buf, "text/") || strstr(buf, "application/x-www-form-urlencoded")))
	RequestType = TEXT;
      if (empty_line(buf)) 
	break; /* end of headers */
      if (PassToServer(buf) && (writestr(out, buf) < 0)) return (1);
    }

    if(writestr(out,ClientAcceptKoi8 ? "\r\n":"Accept: text/x-cyrillic-koi8\r\n\r\n") < 0)
      return 1;

    if (RequestLength) {
      if (RequestType == TEXT) {	/* text */
	while (RequestLength)  {
	  n = mmin(RequestLength,BUFSIZE);
	  if (!(n = fread(buf, 1, n, ifs))) return (1);
	  RequestLength -= n;
	  url_translate(buf); /* We must handle all escapes -> it may be POST request */
	  if (writestr(out, urlbuf) < 0) 
	    return (1);
	}
      }  else { /*binary  data */
	while (RequestLength)  {
	  n = mmin(RequestLength,BUFSIZE);
	  if (!(n = fread(buf, 1, n, ifs))) return (1);
	  if (write(out, buf, n) < 0) return (1);
	  RequestLength -= n;
	}
      }
    }
  }  else    { 
    /* Not HTTP 1.x */
    if (writestr(out, "Accept: */*\r\nAccept: text/x-cyrillic-koi8\r\nUser-Agent: cyrproxy/UNIX\r\n\r\n")	  < 0)
      return (1); 
  }
  return 0;
}


static int
http_response(int in, int out)
{
  static FILE		*ifs = NULL;
  int		haveContLen=0, n;
  static int ResponseLength = 0;
  static int ResponseType = BINARY;
  
  if (ResponseLength)  {
    n=mmin(ResponseLength,BSIZE);
    if((n=read(in,buf,n))>=0) {
      TranslateBuf(buf,n,client_enc->tableto);
      if(write(out,buf,n)<0) return 1;
      ResponseLength-=n;
    } else
      return 1;
    return 0;
  }
  
  ifs = fdopen(in,"r");
  while (fgets(buf, BUFSIZE, ifs) != NULL) 
    { 
      /* Header */
      n = strlen(buf);
      if (strmatch(buf,"Content-Type:") && strstr(buf, "text/"))
	ResponseType = TEXT;
      else if (strmatch(buf, "Content-Length:")) {
	strcpy(urlbuf,buf);
	strws(urlbuf);
	ResponseLength = atoi(strws(NULL));
	haveContLen = 1;
      }
      if (IsHTTP_1_0 && PassToClient(buf) && (write(out, buf, n)) < 0) 
	return (1);
      if (empty_line(buf))
	break;
    }

  /* Response Body */
  if (ResponseType== TEXT) 
    {
      while ((n = fread(buf,1, BUFSIZE, ifs))>0) 
	{
	  TranslateBuf(buf,n, client_enc->tableto);
	  if (write(out, buf,n) < 0) 
	    return (1);
	}
    }
  else  /* Binary response */
    {
      if(!haveContLen) 
	{
	  while ((n = fread(buf,1, BSIZE,ifs)) > 0) {
	    if (write(out, buf, n) < 0) 
	      return(1);
	  }
	} 
      else /* have ContentLen */
	while (ResponseLength) 
	  {
	    n = mmin(ResponseLength,BSIZE);
	    if (!(n = fread(buf,1,n,ifs))) return 1;
	    if(write(out,buf,n) < 0) return 1;
	    ResponseLength -=n;
	  }
    }
  return 1; /* all data processed ? */
}

void 
HttpGW(int in, int  out,encoding* enc, int timeout)
{
  fd_set fds;
  int    n, fdsbits;
  static struct timeval    tout;
  
  client_enc = enc;
  alarm(0);
  fdsbits=mmax(in,out)+1;
  
  while (1) 
    {
      FD_ZERO(&fds);
      FD_SET(in, &fds);
      FD_SET(out, &fds);
      tout.tv_sec = timeout;
      tout.tv_usec = 0;
      if ((n = select(fdsbits, &fds, NULL, NULL, &tout)) > 0) 
	{
	  if (FD_ISSET(in , &fds) && http_request( in , out)) return;
	  if (FD_ISSET(out, &fds) && http_response( out , in)) return;
	} 
      else{
	return;
      }
  }
}

