/* $Id: spy.c,v 1.1 1996/10/27 14:08:28 lexa Exp $ */

/* spy - logger for TCP connections */
/* (C) Alex Tutubalin, 1996, lexa@lexa.ru       */


#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <pwd.h>
#include <sys/socket.h>
#include <signal.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <syslog.h>
#include <string.h>
#include <errno.h>
#include <sys/fcntl.h>
#include <sys/stat.h>

#include "policy.h"
#include "readconf.h"

extern int ConnectTo(char*, char*);

static char targethost[256]="\0";
static char targetport[256]="\0";
static char outfile[256]="";
static int  timeout = TIMEOUT;
int outf=0,inf=0;

static void 
usage(char *name)
{
  printf("usage:\n%s  -p port -h host -f outfile-base\n",name);
}

static int 
processCLOptions(int argc, char *argv[])
{
  extern char *optarg;
  extern int optind;
  int ch;
  while ((ch = getopt(argc, argv, "p:h:f:")) != EOF)
   switch(ch) {
    case 'p':
      strcpy(targetport,optarg);
      break; 
    case 'h':
      strcpy(targethost,optarg);
      break;
    case 'f':
      strcpy(outfile,optarg);
      break;
    case '?':
    default: 
      usage(argv[0]);
    }
  argc -= optind;
  argv += optind;
  return OK;
}

void 
sigfunc(int sig)
{
  closelog();
  exit(1);
}

void
setsig(void)
{
  signal(SIGHUP,sigfunc);
  signal(SIGINT,sigfunc);
  signal(SIGQUIT,sigfunc);
  signal(SIGILL,sigfunc);
  signal(SIGTRAP,sigfunc);
  signal(SIGTERM,sigfunc);
  signal(SIGALRM,sigfunc);
  signal(SIGBUS,sigfunc);
  signal(SIGSEGV,sigfunc);
  /* some peoples comlained that Linux /and other/ do not have SIGSYS signal */
  /* If you have this problem with other signals - comment this signal catching out */
  /* All signal handling in this program have diagnostic purpose only */
#ifdef SIGSYS
  signal(SIGSYS,sigfunc);
#endif
}

int 
datapipe(int inf,int outf,int spyfile)
{
#define BSIZE 2048
  char buf[BSIZE];
  int dsize;
  
  if(0==(dsize=read(inf,buf,BSIZE))) return ERROR;
  write(spyfile,buf,dsize);
  if(dsize!=write(outf,buf,dsize)) return ERROR;
  return OK;
}

void 
simple_gw(int in, int out, int in_spy, int out_spy,int timeout)
{
  int  file_bits,n;
  fd_set fd;
  struct timeval tv;

    alarm(0);
    file_bits=in>out?in+1:out+1;

    while (1) {
        FD_ZERO(&fd);
        FD_SET(in, &fd);
        FD_SET(out, &fd);
        tv.tv_sec = timeout;
        tv.tv_usec = 0;
        if ((n = select(file_bits, &fd, NULL, NULL, &tv)) > 0) {
            if (FD_ISSET(in , &fd) && (ERROR==datapipe( in , out, in_spy))) 
	      return;
            if (FD_ISSET(out, &fd) && (ERROR==datapipe( out , in,out_spy))) 
	      return;
	} 
        else return;
    }
}


int 
main(int argc, char *argv[])
{
  int		outdata=0;
  char tmpbuf[256];
  if(OK!=processCLOptions(argc,argv)) {usage(argv[0]);exit(1);}
  if(!*targethost || !*targetport) { usage(argv[0]);exit(1);}
  sprintf(tmpbuf,"%s.%d.in",outfile,(int)getpid());
  inf = open(tmpbuf,O_WRONLY|O_APPEND|O_CREAT,S_IREAD|S_IWRITE);
  sprintf(tmpbuf,"%s.%d.out",outfile,(int)getpid());
  outf = open(tmpbuf,O_WRONLY|O_APPEND|O_CREAT,S_IREAD|S_IWRITE);
  if(-1==(outdata = ConnectTo(targethost,targetport))) exit(1);
  simple_gw(0,outdata,inf,outf,timeout);
  close(inf);close(outf);
  exit(0);
}


