/* $Id: telnet_gw.c,v 1.5 1996/10/27 14:08:16 lexa Exp $ */

/* 
    (C) Vadim Kurland, 1994
    vadim@gu.kiev.ua

    modified for cyrproxy program by Alex Tutubalin, lexa@lexa.ru
    
    */


#include <arpa/telnet.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

#include "policy.h"
#include "readconf.h"
#include "gateway.h"


static int wait_for_se[2] = { 0 , 0 };
static int cm_stage[2] = { 1 , 1 };

unsigned char  bnr[]={ 255 , 255 };


int nindex(unsigned char *str, int s, int n)
{
  unsigned char *cp;
  if ( (cp = (unsigned char*)memchr(str,s,n))==NULL) return(-1);
  return( (int)(cp-str) );
}

/* telnet gateway */

static int 
telnetPipe(int  in, int out , enum Direction fclient, enum Dataset fd,encoding* enc)
{
  unsigned char *bp, *cp;
  int            n, no, nse, i;

  if ((n = read(in, buf, BSIZE-2 )) > 0) 
    {
      bp=buf;
      bp[n]=0;

      cp=bp; 
      while ( n ) {
	if (wait_for_se[fclient]) goto wse;
	if ( cm_stage[fclient] &&  *cp==IAC ) {
	  switch (cp[1]) 
	  {
          case DONT:
          case DO:
          case WONT:
          case WILL: no=3;
	    break;

	  wse:
	  case SB:   
	    nse=nindex(cp,SE,n);
	    if (nse<0) 
	      {
		no=n;
		wait_for_se[fclient]=1; 
	      }
	    else 
	      {
		no=nse+1; 
		wait_for_se[fclient]=0; 
	      }
	    break;
          default:   no=2;   break;
	  }
	  if (write(out, cp, no) < 0) 
	    return ERROR;
	  cp+=no; n-=no;
        } 
	else 
	  {
	    cm_stage[fclient]=0;
	    no=n;
	    TranslateBuf(cp,no,fclient==FROM_CLIENT?enc->tablefrom:enc->tableto);
	    /*
	            255 (IAC),   
	           IAC IAC
	      */
	    for (i=0; i<no; ++i,++cp) {
	      if (*cp==IAC) write(out, bnr, 2);
	      else          write(out, cp, 1);
	    }
	    n=0;
	  }
      }
      return OK;
    } 
  return ERROR;
}


void 
TelnetGW (int in, int out, encoding *enc, int timeout)
{
  simple_gw(in,out,telnetPipe,enc,timeout);
}

